package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLUnionPWQPolynomial_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLUnionPWQPolynomial extends JNIObject  {
	
	/* @generated */
	protected ISLUnionPWQPolynomial(long ptr) {
		/*** PROTECTED REGION ID(ISLUnionPWQPolynomial_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLUnionPWQPolynomial build(long ptr) {
		return new ISLUnionPWQPolynomial(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLUnionPWQPolynomial_userCode) ENABLED START ***/
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	/**
	 * isl_union_pw_qpolynomial_read_from_str 
	 * 
	 * @generated
	**/
	 public static ISLUnionPWQPolynomial buildFromString(ISLContext ctx, String str) { 
		/*** PROTECTED REGION ID(static_isl_union_pw_qpolynomial_read_from_str) DISABLED START ***/
		ISLUnionPWQPolynomial res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLUnionPWQPolynomial.build(ISLNative.isl_union_pw_qpolynomial_read_from_str(getNativePtr(ctx), str));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_qpolynomial_zero 
	 * 
	@take dim
	 * @generated
	**/
	 public static ISLUnionPWQPolynomial buildZero(ISLSpace dim) { 
		/*** PROTECTED REGION ID(static_isl_union_pw_qpolynomial_zero) DISABLED START ***/
		ISLUnionPWQPolynomial res;
		
		synchronized(LOCK) {
			checkParameters(dim);
			try {
				res = ISLUnionPWQPolynomial.build(ISLNative.isl_union_pw_qpolynomial_zero(getNativePtr(dim)));
			} finally {
				taken(dim);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_qpolynomial_to_string 
	 * 
	 * @generated
	**/
	 public static String _toString(ISLUnionPWQPolynomial upwqp, int format) { 
		/*** PROTECTED REGION ID(static_isl_union_pw_qpolynomial_to_string) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_union_pw_qpolynomial_to_string(getNativePtr(upwqp), format);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_union_pw_qpolynomial_get_ctx 
	 * 
	 * @generated
	**/
	public ISLContext getContext() {
		/*** PROTECTED REGION ID(isl_union_pw_qpolynomial_get_ctx) DISABLED START ***/
		ISLContext res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLContext.build(ISLNative.isl_union_pw_qpolynomial_get_ctx(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_qpolynomial_get_space 
	 * 
	 * @generated
	**/
	public ISLSpace getSpace() {
		/*** PROTECTED REGION ID(isl_union_pw_qpolynomial_get_space) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLSpace.build(ISLNative.isl_union_pw_qpolynomial_get_space(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_qpolynomial_copy 
	 * 
	 * @generated
	**/
	public ISLUnionPWQPolynomial copy() {
		/*** PROTECTED REGION ID(isl_union_pw_qpolynomial_copy) DISABLED START ***/
		ISLUnionPWQPolynomial res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLUnionPWQPolynomial.build(ISLNative.isl_union_pw_qpolynomial_copy(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_qpolynomial_free 
	 * 
	 * @take this
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(isl_union_pw_qpolynomial_free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				ISLNative.isl_union_pw_qpolynomial_free(getNativePtr(this));
			} finally {
				taken(this);
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_qpolynomial_plain_is_equal 
	 * 
	 * @generated
	**/
	public boolean isPlainEqual(ISLUnionPWQPolynomial upwqp2) {
		/*** PROTECTED REGION ID(isl_union_pw_qpolynomial_plain_is_equal) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_union_pw_qpolynomial_plain_is_equal(getNativePtr(this), getNativePtr(upwqp2)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_qpolynomial_add_pw_qpolynomial 
	 * 
	 * @take this pwqp
	 * @generated
	**/
	public ISLUnionPWQPolynomial add(ISLPWQPolynomial pwqp) {
		/*** PROTECTED REGION ID(isl_union_pw_qpolynomial_add_pw_qpolynomial) DISABLED START ***/
		ISLUnionPWQPolynomial res;
		
		synchronized(LOCK) {
			checkParameters(this, pwqp);
			try {
				res = ISLUnionPWQPolynomial.build(ISLNative.isl_union_pw_qpolynomial_add_pw_qpolynomial(getNativePtr(this), getNativePtr(pwqp)));
			} finally {
				taken(this);
				taken(pwqp);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_qpolynomial_add 
	 * 
	 * @take this upwqp2
	 * @generated
	**/
	public ISLUnionPWQPolynomial add(ISLUnionPWQPolynomial upwqp2) {
		/*** PROTECTED REGION ID(isl_union_pw_qpolynomial_add) DISABLED START ***/
		ISLUnionPWQPolynomial res;
		
		synchronized(LOCK) {
			checkParameters(this, upwqp2);
			try {
				res = ISLUnionPWQPolynomial.build(ISLNative.isl_union_pw_qpolynomial_add(getNativePtr(this), getNativePtr(upwqp2)));
			} finally {
				taken(this);
				taken(upwqp2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_qpolynomial_sub 
	 * 
	 * @take this upwqp2
	 * @generated
	**/
	public ISLUnionPWQPolynomial sub(ISLUnionPWQPolynomial upwqp2) {
		/*** PROTECTED REGION ID(isl_union_pw_qpolynomial_sub) DISABLED START ***/
		ISLUnionPWQPolynomial res;
		
		synchronized(LOCK) {
			checkParameters(this, upwqp2);
			try {
				res = ISLUnionPWQPolynomial.build(ISLNative.isl_union_pw_qpolynomial_sub(getNativePtr(this), getNativePtr(upwqp2)));
			} finally {
				taken(this);
				taken(upwqp2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_qpolynomial_mul 
	 * 
	 * @take this upwqp2
	 * @generated
	**/
	public ISLUnionPWQPolynomial mul(ISLUnionPWQPolynomial upwqp2) {
		/*** PROTECTED REGION ID(isl_union_pw_qpolynomial_mul) DISABLED START ***/
		ISLUnionPWQPolynomial res;
		
		synchronized(LOCK) {
			checkParameters(this, upwqp2);
			try {
				res = ISLUnionPWQPolynomial.build(ISLNative.isl_union_pw_qpolynomial_mul(getNativePtr(this), getNativePtr(upwqp2)));
			} finally {
				taken(this);
				taken(upwqp2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_qpolynomial_scale_val 
	 * 
	 * @take this v
	 * @generated
	**/
	public ISLUnionPWQPolynomial scale(ISLVal v) {
		/*** PROTECTED REGION ID(isl_union_pw_qpolynomial_scale_val) DISABLED START ***/
		ISLUnionPWQPolynomial res;
		
		synchronized(LOCK) {
			checkParameters(this, v);
			try {
				res = ISLUnionPWQPolynomial.build(ISLNative.isl_union_pw_qpolynomial_scale_val(getNativePtr(this), getNativePtr(v)));
			} finally {
				taken(this);
				taken(v);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_qpolynomial_domain 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionSet domain() {
		/*** PROTECTED REGION ID(isl_union_pw_qpolynomial_domain) DISABLED START ***/
		ISLUnionSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionSet.build(ISLNative.isl_union_pw_qpolynomial_domain(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_qpolynomial_intersect_domain 
	 * 
	 * @take this uset
	 * @generated
	**/
	public ISLUnionPWQPolynomial intersectDomain(ISLUnionSet uset) {
		/*** PROTECTED REGION ID(isl_union_pw_qpolynomial_intersect_domain) DISABLED START ***/
		ISLUnionPWQPolynomial res;
		
		synchronized(LOCK) {
			checkParameters(this, uset);
			try {
				res = ISLUnionPWQPolynomial.build(ISLNative.isl_union_pw_qpolynomial_intersect_domain(getNativePtr(this), getNativePtr(uset)));
			} finally {
				taken(this);
				taken(uset);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_qpolynomial_intersect_params 
	 * 
	 * @take this set
	 * @generated
	**/
	public ISLUnionPWQPolynomial intersectParams(ISLSet set) {
		/*** PROTECTED REGION ID(isl_union_pw_qpolynomial_intersect_params) DISABLED START ***/
		ISLUnionPWQPolynomial res;
		
		synchronized(LOCK) {
			checkParameters(this, set);
			try {
				res = ISLUnionPWQPolynomial.build(ISLNative.isl_union_pw_qpolynomial_intersect_params(getNativePtr(this), getNativePtr(set)));
			} finally {
				taken(this);
				taken(set);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_qpolynomial_intersect_domain_wrapped_domain 
	 * 
	 * @take this uset
	 * @generated
	**/
	public ISLUnionPWQPolynomial intersectDomainWrappedDomain(ISLUnionSet uset) {
		/*** PROTECTED REGION ID(isl_union_pw_qpolynomial_intersect_domain_wrapped_domain) DISABLED START ***/
		ISLUnionPWQPolynomial res;
		
		synchronized(LOCK) {
			checkParameters(this, uset);
			try {
				res = ISLUnionPWQPolynomial.build(ISLNative.isl_union_pw_qpolynomial_intersect_domain_wrapped_domain(getNativePtr(this), getNativePtr(uset)));
			} finally {
				taken(this);
				taken(uset);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_qpolynomial_intersect_domain_wrapped_range 
	 * 
	 * @take this uset
	 * @generated
	**/
	public ISLUnionPWQPolynomial intersectDomainWrappedRange(ISLUnionSet uset) {
		/*** PROTECTED REGION ID(isl_union_pw_qpolynomial_intersect_domain_wrapped_range) DISABLED START ***/
		ISLUnionPWQPolynomial res;
		
		synchronized(LOCK) {
			checkParameters(this, uset);
			try {
				res = ISLUnionPWQPolynomial.build(ISLNative.isl_union_pw_qpolynomial_intersect_domain_wrapped_range(getNativePtr(this), getNativePtr(uset)));
			} finally {
				taken(this);
				taken(uset);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_qpolynomial_eval 
	 * 
	 * @take this pnt
	 * @generated
	**/
	public ISLVal eval(ISLPoint pnt) {
		/*** PROTECTED REGION ID(isl_union_pw_qpolynomial_eval) DISABLED START ***/
		ISLVal res;
		
		synchronized(LOCK) {
			checkParameters(this, pnt);
			try {
				res = ISLVal.build(ISLNative.isl_union_pw_qpolynomial_eval(getNativePtr(this), getNativePtr(pnt)));
			} finally {
				taken(this);
				taken(pnt);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_qpolynomial_coalesce 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionPWQPolynomial coalesce() {
		/*** PROTECTED REGION ID(isl_union_pw_qpolynomial_coalesce) DISABLED START ***/
		ISLUnionPWQPolynomial res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionPWQPolynomial.build(ISLNative.isl_union_pw_qpolynomial_coalesce(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_qpolynomial_gist 
	 * 
	 * @take this context
	 * @generated
	**/
	public ISLUnionPWQPolynomial gist(ISLUnionSet context) {
		/*** PROTECTED REGION ID(isl_union_pw_qpolynomial_gist) DISABLED START ***/
		ISLUnionPWQPolynomial res;
		
		synchronized(LOCK) {
			checkParameters(this, context);
			try {
				res = ISLUnionPWQPolynomial.build(ISLNative.isl_union_pw_qpolynomial_gist(getNativePtr(this), getNativePtr(context)));
			} finally {
				taken(this);
				taken(context);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_qpolynomial_gist_params 
	 * 
	 * @take this context
	 * @generated
	**/
	public ISLUnionPWQPolynomial gistParams(ISLSet context) {
		/*** PROTECTED REGION ID(isl_union_pw_qpolynomial_gist_params) DISABLED START ***/
		ISLUnionPWQPolynomial res;
		
		synchronized(LOCK) {
			checkParameters(this, context);
			try {
				res = ISLUnionPWQPolynomial.build(ISLNative.isl_union_pw_qpolynomial_gist_params(getNativePtr(this), getNativePtr(context)));
			} finally {
				taken(this);
				taken(context);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_qpolynomial_align_params 
	 * 
	 * @take this model
	 * @generated
	**/
	public ISLUnionPWQPolynomial alignParams(ISLSpace model) {
		/*** PROTECTED REGION ID(isl_union_pw_qpolynomial_align_params) DISABLED START ***/
		ISLUnionPWQPolynomial res;
		
		synchronized(LOCK) {
			checkParameters(this, model);
			try {
				res = ISLUnionPWQPolynomial.build(ISLNative.isl_union_pw_qpolynomial_align_params(getNativePtr(this), getNativePtr(model)));
			} finally {
				taken(this);
				taken(model);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLUnionPWQPolynomial_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
